/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: RCSL 1.0/RPSL 1.0 
 *  
 * Portions Copyright (c) 1995-2002 RealNetworks, Inc. All Rights Reserved. 
 *      
 * The contents of this file, and the files included with this file, are 
 * subject to the current version of the RealNetworks Public Source License 
 * Version 1.0 (the "RPSL") available at 
 * http://www.helixcommunity.org/content/rpsl unless you have licensed 
 * the file under the RealNetworks Community Source License Version 1.0 
 * (the "RCSL") available at http://www.helixcommunity.org/content/rcsl, 
 * in which case the RCSL will apply. You may also obtain the license terms 
 * directly from RealNetworks.  You may not use this file except in 
 * compliance with the RPSL or, if you have a valid RCSL with RealNetworks 
 * applicable to this file, the RCSL.  Please see the applicable RPSL or 
 * RCSL for the rights, obligations and limitations governing use of the 
 * contents of the file.  
 *  
 * This file is part of the Helix DNA Technology. RealNetworks is the 
 * developer of the Original Code and owns the copyrights in the portions 
 * it created. 
 *  
 * This file, and the files included with this file, is distributed and made 
 * available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER 
 * EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS ALL SUCH WARRANTIES, 
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS 
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. 
 * 
 * Technology Compatibility Kit Test Suite(s) Location: 
 *    http://www.helixcommunity.org/content/tck 
 * 
 * Contributor(s): 
 *  
 * ***** END LICENSE BLOCK ***** */ 

#ifndef _IHXIUNKNOWN_TRACKER_H_
#define _IHXIUNKNOWN_TRACKER_H_

/*!
    @header ihxiunknowntracker.h
 */

#include "hxcom.h"
#include "hxtypes.h"

// {AC445512-52BA-11d4-94F3-00D0B7103550}
DEFINE_GUID( IID_IHXIUnknownTracker, 0xac445512, 0x52ba, 0x11d4, 0x94, 0xf3, 0x0, 0xd0, 0xb7, 0x10, 0x35, 0x50 );

/*!
    @interface IHXIUnknownTracker
 */
DECLARE_INTERFACE_( IHXIUnknownTracker, IUnknown )
{
    /*!
	@function OnIUnknownAddRef
     */
    STDMETHOD_( void, OnIUnknownAddRef ) ( THIS_ IUnknown* pIUnknown, ULONG32 postAddRefRefCount ) PURE;
    
    /*!
	@function OnIUnknownRelease
     */
    STDMETHOD_( void, OnIUnknownRelease ) ( THIS_ IUnknown* pIUnknown, ULONG32 preReleaseRefCount ) PURE;
    
    /*!
	@function AddIUnknownToWatchList
     */
    STDMETHOD ( AddIUnknownToWatchList ) ( THIS_ IUnknown* pIUnknown, const char* pName ) PURE;

    /*!
	@function RemoveIUnknownFromWatchList
     */
    STDMETHOD_( void, RemoveIUnknownFromWatchList ) ( THIS_ IUnknown* pIUnknown ) PURE;

    /*!
	@function ActivateWatchList
     */
    STDMETHOD_( void, ActivateWatchList ) ( THIS_ BOOL isActivated ) PURE;
};

#endif // _IHXIUNKNOWN_TRACKER_H_
